package com.kyub.idea.plugin.mantis;

import com.intellij.openapi.vcs.checkin.CheckinHandler;
import com.intellij.openapi.vcs.ui.RefreshableOnComponent;
import com.intellij.openapi.vcs.CheckinProjectPanel;
import com.intellij.openapi.diagnostic.Logger;
import com.kyub.idea.plugin.mantis.gui.checkin.CheckInRefreshable;
import com.kyub.idea.plugin.mantis.gui.checkin.CheckInDialog;
import com.kyub.idea.plugin.mantis.service.ServiceManager;
import org.jetbrains.annotations.Nullable;
import org.mantisbt.connect.service.IssueData;

import javax.swing.*;

/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 20-set-2006
 * Time: 18.11.26
 * To change this template use File | Settings | File Templates.
 */
public final class MantisCheckinHandler extends CheckinHandler {

    private  JCheckBox optCheckbox = null;
    private boolean updateIssues = false;
    private  CheckinProjectPanel panel = null;

    private ServiceManager serviceManager;
    private CheckInDialog dialog;

    private final static Logger LOG = Logger.getInstance(MantisCheckinHandler.class.getName());

    private JCheckBox createCheckbox()
      {
          JCheckBox checkBox = new JCheckBox("Resolve Mantis Issues");
          checkBox.setAlignmentX(0.0F);
          checkBox.setHorizontalAlignment(2);
          return checkBox;
      }


    public MantisCheckinHandler(final CheckinProjectPanel panel) {
        this.panel = panel;
        try {
            serviceManager = ServiceManager.getInstance();
        } catch (Exception e) {
            LOG.error(e);
        }

        optCheckbox = createCheckbox();
    }


    public final ReturnResult beforeCheckin() {
        System.out.println("optCheckbox = " + optCheckbox.isSelected());
        if(optCheckbox.isSelected()){
            dialog = new CheckInDialog();
            dialog.pack();
            dialog.show();
            updateIssues = dialog.isResult();


        }
        return super.beforeCheckin();
    }


    public final void checkinSuccessful() {

         if(updateIssues)
                 {
                     IssueData[] datas = dialog.getSelectedIssues();

                     for (int i = 0; i < datas.length; i++) {
                         IssueData data = datas[i];
                         serviceManager.addComment(data, panel.getCommitMessage());
                         serviceManager.solveIssue(data);
                     }

                     System.out.println("do update issue...  "+ panel.getCommitMessage() );
                 }
    }

    @Nullable
    public final RefreshableOnComponent getBeforeCheckinConfigurationPanel() {
        return new CheckInRefreshable(optCheckbox);
    }
}
