package com.kyub.idea.plugin.mantis.gui;

import org.mantisbt.connect.service.IssueData;

import javax.swing.table.AbstractTableModel;
import java.util.Arrays;

import com.kyub.idea.plugin.mantis.gui.vo.IssueComparator;

/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 22-set-2006
 * Time: 10.38.46
 * To change this template use File | Settings | File Templates.
 */
public abstract class AbsIssueTableModel extends AbstractTableModel {
    IssueData[] issues;

     public AbsIssueTableModel(IssueData[] issues ) {
        if(issues != null){
        this.issues = issues;
        Arrays.sort(this.issues,new IssueComparator());
        }
    }

    public final IssueData[] getIssues() {
        return issues;
    }

    public final void setIssues(IssueData[] issues) {
        this.issues = issues;
    }

    protected final String formatDescription(int row) {
        String description = issues[row].getSummary();
        if(description.length() > 35)
            description = description.substring(0,30)+"[...]";
        return description;
    }

    public final int getRowCount() {
        if(issues != null)
         return issues.length;
        else return 0;
    }

    public final int getColumnCount() {
        return 3;
    }
}
