package com.kyub.idea.plugin.mantis.gui.checkin;

import com.kyub.idea.plugin.mantis.gui.AbsIssueTableModel;
import com.kyub.idea.plugin.mantis.gui.vo.SelectableIssue;
import org.mantisbt.connect.service.IssueData;

import java.util.ArrayList;

/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 22-set-2006
 * Time: 10.40.37
 * To change this template use File | Settings | File Templates.
 */
public final class FixinIssueTableModel extends AbsIssueTableModel {

    private SelectableIssue[] selectables;

    public FixinIssueTableModel(IssueData[] issues) {
        super(issues);
        selectables = new SelectableIssue[issues.length];
        for (int i = 0; i < issues.length; i++) {
            IssueData issue = issues[i];
            selectables[i] = new SelectableIssue(issue);
        }

    }


    public final boolean isCellEditable(int i, int i1) {
        return (i1 == 0);
    }


    public void setValueAt(Object object, int i, int i1) {
        if (object instanceof Boolean) {
            Boolean aBoolean = (Boolean) object;
            selectables[i].setSelected(aBoolean);
        }

    }

    public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }
    

    public final Object getValueAt(int row, int col) {
        switch(col){
         case 0: return selectables[row].isSelected();
         case 1: return getIssues()[row].getId();
         case 2: return formatDescription(row);
         default: return row;
        }

    }


    public final String getColumnName(int col) {
        switch(col){
            case 0: return "Solve";
            case 1: return "ID";
            case 2: return "Description";
            default: return ""+col;
        }
    }

    protected IssueData[] getSelectedIssues(){

        ArrayList<IssueData> tmp = new ArrayList<IssueData>();
        for (int i = 0; i < selectables.length; i++) {
            SelectableIssue selectable = selectables[i];
            if(selectable.isSelected())
                tmp.add(selectable.getIssue());
        }

        return tmp.toArray(new IssueData[tmp.size()]);

    }
}
