package com.kyub.idea.plugin.mantis.gui.config;

import org.mantisbt.connect.service.ProjectData;

import javax.swing.*;

import com.kyub.idea.plugin.mantis.service.ServiceManager;
import com.kyub.idea.plugin.mantis.config.ConfigData;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 19-set-2006
 * Time: 16.09.43
 * To change this template use File | Settings | File Templates.
 */
public final class ConfigForm {
    private JCheckBox enableCheck;
    private JLabel endpointLabel;
    private JLabel usernaleLabel;
    private JLabel passwordLabel;
    private JLabel projectLabel;
    private JButton loadProjectsBtn;
    private JTextField endPointText;
    private JTextField usernameText;
    private JPasswordField passwordPasswordField;
    private JComboBox projectsCombo;
    private JPanel mainPanel;
    private ProjectData[] datas;


    public final JPanel getMainPanel() {
        return mainPanel;
    }

    public static void main(String[] args) {
        JFrame frame = new JFrame("Test");
        ConfigForm configForm = new ConfigForm();

        frame.setContentPane(configForm.mainPanel);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.pack();
        frame.setVisible(true);


    }

    public final void setData(ConfigData data) {
        if (data != null) {
            enableCheck.setSelected(data.isEnabled());
            endPointText.setText(data.getEndpointUrl());
            usernameText.setText(data.getUsername());
            passwordPasswordField.setText(data.getPassword());

            refreshProjects();
            if (accaountOk() && datas != null) {
                for (int i = 0; i < datas.length; i++) {
                    ProjectData projectData = datas[i];
                    if (projectData.getId().longValue() == data.getProjectId()) {
                        projectsCombo.setSelectedIndex(i);

                    }
                }
            }
        }
    }

    public final void getData(ConfigData data) {
        data.setEnabled(enableCheck.isSelected());
        data.setEndpointUrl(endPointText.getText());
        data.setUsername(usernameText.getText());
        data.setPassword(passwordPasswordField.getText());
        data.setProjectId(getProject().getId().longValue());
    }

    public final ConfigData getData() {
        ConfigData data = new ConfigData();
        data.setEnabled(enableCheck.isSelected());
        data.setEndpointUrl(endPointText.getText());
        data.setUsername(usernameText.getText());
        data.setPassword(passwordPasswordField.getText());
        data.setProjectId(getProject().getId().longValue());
        return data;
    }

    public final boolean isModified(ConfigData data) {
        if (data == null) return true;
        if (enableCheck.isSelected() != data.isEnabled()) return true;
        if (endPointText.getText() != null ? !endPointText.getText().equals(data.getEndpointUrl()) : data.getEndpointUrl() != null)
            return true;
        if (usernameText.getText() != null ? !usernameText.getText().equals(data.getUsername()) : data.getUsername() != null)
            return true;
        return passwordPasswordField.getText() != null ? !passwordPasswordField.getText().equals(data.getPassword()) : data.getPassword() != null;

    }

    private ProjectData getProject() {


        Object prjName = projectsCombo.getItemAt(projectsCombo.getSelectedIndex());
        ProjectData p = null;
        if (datas != null) {
            for (int i = 0; i < datas.length; i++) {
                ProjectData data = datas[i];
                if (data.getName().equals(prjName))
                    p = data;
            }
        }

        return p;

    }

    protected final void refreshProjects() {

        if (accaountOk()) {
            ServiceManager serviceManager = ServiceManager.init(endPointText.getText(), usernameText.getText(), passwordPasswordField.getText());
            projectsCombo.removeAllItems();
            datas = serviceManager.getProjects();
            for (int i = 0; i < datas.length; i++) {
                ProjectData data = datas[i];
                if (data.getEnabled())
                    projectsCombo.addItem(data.getName());
            }
        }

    }

    private boolean accaountOk() {

        return verify(endPointText.getText()) && verify(usernameText.getText()) && verify(passwordPasswordField.getText());
    }

    private boolean verify(final String text) {
        return (text != null && text.length() > 0);
    }


    private void createUIComponents() {

        endPointText = new JTextField();
        loadProjectsBtn = new JButton();
        loadProjectsBtn.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionEvent) {
                refreshProjects();
            }
        });
    }
}
