package com.kyub.idea.plugin.mantis.gui.consolle;

import org.mantisbt.connect.service.IssueData;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public final class InfoDialog extends JDialog {
    private JPanel contentPane;
    private JButton buttonOK;
    private JButton buttonCancel;
    private JTable noteTable;
    private JLabel issueIdLabel;
    private JLabel issueIdVal;
    private JLabel issueText;
    private JLabel severityLabel;
    private JLabel openDateLabel;
    private JLabel priorityLabel;
    private JLabel openerLabel;
    private JLabel statusLabel;
    private JScrollPane notePanel;
    private JLabel severityVal;
    private JLabel priorityVal;
    private JLabel statusVal;
    private JLabel openDateVal;
    private JLabel openerVal;
    private JLabel issueTextVal;
    private JScrollPane issueTextScroll;

    public InfoDialog(IssueData issueData) {
        setContentPane(contentPane);
        setModal(true);
        getRootPane().setDefaultButton(buttonOK);
        setTitle("Issue "+issueData.getId()+" details");

        buttonOK.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onOK();
            }
        });

        buttonCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onCancel();
            }
        });

// call onCancel() when cross is clicked
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                onCancel();
            }
        });

// call onCancel() on ESCAPE
        contentPane.registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onCancel();
            }
        }, KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);

        Dimension dimension = new Dimension(300, 450);
        this.setPreferredSize(dimension);
        this.setMinimumSize(dimension);

        issueIdVal.setText(issueData.getId().toString());
        openDateVal.setText(issueData.getDate_submitted().getTime().toString());
        openerVal.setText(issueData.getReporter().getName());
        priorityVal.setText(issueData.getPriority().getName());
        severityVal.setText(issueData.getSeverity().getName());
        statusVal.setText(issueData.getStatus().getName());

        issueTextVal.setText(issueData.getDescription());

        noteTable.setModel(new IssueNoteTableModel(issueData.getNotes()));
    }

    private void onOK() {
// add your code here
        dispose();
    }

    private void onCancel() {
// add your code here if necessary
        dispose();
    }

    public static void main(String[] args) {
        InfoDialog dialog = new InfoDialog(new IssueData());
        dialog.pack();
        dialog.show();
        System.exit(0);
    }
}
